// OK
// test emission simple chaine de caractere avec DMA
// sprintf ok


#include <p33FJ64MC802.h>
#include <stdio.h>
#include <timer.h>
#include "../../drivers/delay.h"
#include "../../drivers/drvUART.h"


//config oscillateur
_FOSCSEL(FNOSC_PRIPLL);								// Choix du oscillateur + PLL
_FOSC(FCKSM_CSDCMD & OSCIOFNC_OFF  & POSCMD_XT);	// Pas de basculement d'horloge
													// pas de OSC2
													// type d'oscillateur XT
_FWDT(FWDTEN_OFF); // watchdog off;



void InitPORT_AND_PIN() 
{  // depend du schema de la carte
	// Rx : RP15
	// Tx:RP14
	_U1RXR=15;	                    //RX sur RP15/RB15
	_RP14R=3;                        //TX sur RP14/RB14
	
	TRISBbits.TRISB15=0; //RP15/RB15 en sortie

}

	void InitClock2() 
{   // CHOIX DES COEF DE LA PLL : voir notice OSCILLATOT
	// FOSC = FIN •(M/(N1*N2))  et Fcy=Fosc/2 = fréquence de fct des périphriques
	// ex: quartz 8Mhz et Fosc=80Mhz => Fosc=8M*(40/4)
	PLLFBD = 38;				// M = 40       
	CLKDIVbits.PLLPOST = 0;		// N1 = 2
	CLKDIVbits.PLLPRE = 0;		// N2 = 2
	OSCTUN = 0;
	RCONbits.SWDTEN = 0;

	while(OSCCONbits.LOCK != 1) {}; // attente verrouillage PLL
}
	

//int __C30_UART;
unsigned char BUFF[50]={'i','u','t','\n','\0'};

int main (void)

{	InitClock2() ; //init oscillateur

	InitPORT_AND_PIN(); // init broche remapable
	InitUART1_TxDMA0(); // init UART with Tx on DMA0 


	// stout redirect UART  with DMA
	printf("456\n"); // \n is needed
	Delay(Delay_15mS_Cnt); 
	printf("test %d %f\n",10,22.565); // \n is needed


	for (;;)
	{
		Delay(Delay_15mS_Cnt); // tempo BLOQUANTE: attention pour demo uniquement!!!
	
		UART_DMAputs(BUFF);
	
	}
}
